{****************************************************************************}
{                   DBFPROC v1.97b1  Last mode 18.06.1997.                  }
{  ⥪ ࠡ⪨ 䠩   ⨯ .DBF  dBase,FoxBase,Clipper }
{    (C) ॥ ࣥ ஢                      .          }
{============================================================================}
{    䮭:  (7-081-00) 66-99-15 譨     FidoNet: 2:5019/5.1         }
{                                                            aka             }
{     (18.00 - 08.00 Msk)  3-03-51  -------------->  2:5019/5           }
{****************************************************************************}
unit DBFProc;
interface
uses
  DB,
  Objects,
  Classes,
  SysUtils,
  Dialogs,
  ANSI_OEM;

{----------------------------------------------------------------------------}
const
    dBaseIII       = $03;  {   祭 }
    dBaseIIIMemo   = $83;  {  㫥      }
    dBaseIVMemo    = $8B;  {   䠩    }
    dBaseIVSQL     = $63;  {   ࠧ ᨩ  }
    FoxPro         = $05;
    FoxProMemo     = $F5;

    CopyRight = '  (C) ॥ ࣥ ஢ . ';


type
    RFileHeader= record   { *** ࢠ   ***  L=32 }
   {+0}      DBType,                           {  7 6 5 4 3 2 1 0
                                                         L- 
                                                        L---   ᨨ
                                                       L----- 
                                                      L-------  DBT [ DBASE IV]
                                                     L--------- ???
                                                    L-----------   SQL [⮫쪮  DBASE IV]
                                                   L------------- 
                                                  L--------------- 祭 䠩 DBT  }
   {+1}      Year,                            {  ᫥ 䨪樨 }
   {+2}      Month,                           {  ---------//-------- }
   {+3}      Day       : Byte;                {   ---------//-------- }
   {+4}      RecCount  : LongInt;             { ᫮ ᥩ  㤠}
   {+8}      HeaderSize: Word;                {  ࢮ }
   {+10}     RecordSize: Longint;             {   }
   {+14}     FDelayTrans : Byte;              {  প ࠭樨 }
   {+15}     Reserve2 : Array[1..13] of Byte; { ࢭ  }
   {+28}     FlagMDX  : Byte;                 {  祭 ⢥-
                                                  1 -  䠩
                                                .MDX, 0 -  }
   {+29}     Reserve3 : Array[1..3] of Byte;  {  }
            end;

{............................................................................}
type
    RMemoHeader = record  { *** p  DBT - 䠩 *** L = 512 }
             FreePage : Longint;     { p 䠩 }
             Reserve  : Array[1..508] of Byte;
            end;
{............................................................................}
type
    TFieldName = Array[1..10] of Char;

    RDescriptor = record   { ***  (ਯ)  *** L= 32 }
    {+0}     FieldName : TFieldName;           {   }
    {+10}    FieldEnd  : Char;                 { pp騩  00h }
    {+11}    FieldType : Char;                 {   C,D,L,N,M}
    {+12}    FieldDisp : LongInt;              { 饭    }
    {+16}    FieldLen,                         {   }
    {+17}    FieldDec  : Byte;                 {   ᫥ 窨 }
    {+18}    A1 : Array[1..13] of Byte;        {  }
    {+31}    FlagTagMDX : Byte;                {  ⥣ ᭮
                                                 䠩 MDX, 1 -  -
                                                 ஢, 0 -  }
            end;

    PDescriptor =^TDescriptor;
    TDescriptor = Object(TObject)  { ***  (ਯ)  *** }
             FieldName : TFieldName;           {   }
             FieldType : Char;                 {   C,D,L,N,M}
             FieldDisp : LongInt;              { 饭    }
             FieldLen,                         {   }
             FieldDec  : Byte;                 {   ᫥ 窨 }
             FlagTagMDX : Byte;             {  ⥣ ᭮
                                                 䠩 MDX }
             constructor Init(DRec : RDescriptor);
             procedure   GetData(var DRec: RDescriptor);
             function    GetName : String;
             function    GetType : Char;
            end;

{............................................................................}
const
   dbfFileEmpty    = 100;
   dbfENoFileName  = 101;
   dbfEFileNotFound= 102;
   dbfECreate      = 103;
   dbfEOpen        = 104;
   dbfESeek        = 105;
   dbfERead        = 106;
   dbfEWrite       = 107;
   dbfEOutOfMemory = 108;
   dbfEDestruct    = 109;
   dbfECreateList  = 110;
   dbfEOutOfNumber = 111;

   crEFileNotFound = 200;
   crEOutOfMemory  = 201;

 type
   PBaseElem = ^TBaseElem;
   TBaseElem = Object(TObject)
     ElName  : String[12];
     ElType  : Char;
     ElLen   : Integer;
     ElDec   : Integer;
     constructor Init(S : String);
     destructor  Done; virtual;
   end;
{..........................................................................}

 type
   PBaseList = ^TBaseList;
   TBaseList = Object(TObject)
     cbResult : Longint;
     List   : PCollection;
     TxtF   : Text;
     TxtName : String;

     constructor Init(TxtFName : String);
     destructor  Done; virtual;
     procedure   Add(RS: String);
     function    GetElem(ItemNum : Integer): PBaseElem;
     function    GetCount : Integer;
    private
      InitF : Boolean;
   end;


{............................................................................}
type
 PDBF = ^TDBF;
 TDBF = Object(TObject)
    FlagInit      : Byte;   { ਧ ᯥ譮 樠樨 ꥪ }
    DBFName       : String[64]; {  䠩   }
    STRName       : String[64];
    Res           : Longint; {  樨 }
 private
    DBFHandle     : Word;    { Hp p 䠩   }
    DBFHeader     : RFileHeader;  {     䠩 }
    Descriptor    : RDescriptor;  {  ਯ  }
    DList         : PCollection;  { ᮪ 㪠⥫ ਯ஢}
 public

{---------------------------------------------------------------------------}
{ ==== 樨 饣 祭 ====                                      }
{...........................................................................}
    constructor Init(DBName: String);  { ⨥   }
    destructor  Done; virtual;        { ⨥  }
    procedure   InitStructFile(SName : String);
    procedure   EraseDB;    { ⮦   }
    procedure   ErrorHandle(Error :Longint); virtual;
                                      { 楤 ࠡ⪨ 訡 }
    procedure   CreateHeader(FType : Byte);
                                 { ⮢ ⮣  }
                                 { FType - ⨯ 䠩 dBase,dBaseIIIMemo...}

    procedure   WriteHeader;  {    䠩 }

    function    DeleteMDX : Byte;
    function    CreateBaseStructOnFile : Boolean;
                                 {    ᠭ  ⥪⮢ -}
    function    CreateBaseStructOnList(BaseList: PBaseList) : Boolean;
                                 {    ᠭ  ᯨ᪥}
{...........................................................................}
{ ====  樨  ﬨ ᪮   ====                           }
{...........................................................................}
    procedure AppendField(Name : String; FTp : Char; LenI,LenD : Byte);
                                  {   Name   ⮩  }
    function  GetNumField(Name : String) :Integer;
                                  {     Name     }
    function  GetFieldName(Num : Integer) :String;
                                  {         }
    function  GetTypeNum(Num : Integer) :Char;
                                  {  ⨯   Num }
    function  GetType(Name : String) :Char;
                                  {  ⨯  Name }
    function  GetLengthNum(Num : Integer): Integer;
                                  {      }
    function  GetLength(Name : String): Integer;
                                  {      }
    function  GetDispNum(Num : Integer): Integer;
                                  {  ᬥ饭    }
    function  GetDisp(Name : String): Integer;
                                  {  ᬥ饭    }
 end;

{===========================================================================}
{ ====  騥 㭪樨  楤  ====                                     }
{...........................................................................}
function GetAliasPath(Alias : String) : String; {   ᥢ }


{===========================================================================}
{ ====  ८ࠧ ⨯  ====                                          }
{...........................................................................}
function  RealToString(D : Double; Ln,Dc : Integer) : String;
                                                 { ᭮  ப }
function  StringToReal(S: String) : Double;     { ப  ᭮ }
function  StringToInteger(S: String) : LongInt; { ப  楫 }

{...........................................................................}
{ ====  p樨  p  ====                                          }
{...........................................................................}
function  SpaceCut(DString: String): String; {   殢 ஡ }

{...........................................................................}
const
  dbFlagFiles : Boolean = False; { ਧ 樠樨 ⢠ 䠩 }

  erInvalidHandle         = $06;  { Hp HANDLE-p 䠩 }
  erSharedViolation       = $20;  { 訡 p 䠩 }
  erLockingViolation      = $21;  { 訡 p 䠩 }
  erSharingBufferOverflov = $24;  { p ⥪ SHARE }

implementation

{----------------------------------------------------------------------------}
function SpaceCut(DString: String): String;
var
  I : Byte;
  S : String;
begin
  S := DString;
  I := Length(S);
  while (S[I] in [' ',#0,#255]) and (I > 0) do Dec(I);
  S[0] := Chr(I);
  if I > 0 then
   begin
     I := 1;
     while S[I] in [' ',#0,#255] do Inc(I);
     SpaceCut := Copy(S,I,Length(S));
   end
    else SpaceCut := '';
end;

{---------------------------------------------------------------------------}
constructor TDescriptor.Init;
begin
  inherited Init;
  FieldName := DRec.FieldName;
  FieldType := UpCase(DRec.FieldType);
  FieldDisp := DRec.FieldDisp;
  FieldLen  := DRec.FieldLen;
  FieldDec  := DRec.FieldDec;
  FlagTagMDX := DRec.FlagTagMDX;
end;

{............................................................................}
procedure TDescriptor.GetData;
begin
  DRec.FieldName := FieldName;
  DRec.FieldEnd  := #0;
  DRec.FieldType := FieldType;
  DRec.FieldDisp := FieldDisp;
  DRec.FieldLen  := FieldLen;
  DRec.FieldDec  := FieldDec;
  DRec.FlagTagMDX := FlagTagMDX;
end;

{............................................................................}
function TDescriptor.GetName;
var
  S : String;
  B : Byte;
begin
  S := '';
  for B := 1 to 10 do
   begin
     if FieldName[B] = #0 then Break
                          else S := S+ FieldName[B];
   end;
  GetName := AnsiUpperCase(SpaceCut(S));
end;

{............................................................................}
function TDescriptor.GetType;
begin
  GetType := UpCase(FieldType);
end;

{----------------------------------------------------------------------------}
constructor TBaseElem.Init(S : String);
var
  WS : String;
  P,L,I  : Integer;

begin
  inherited Init;
  if (Pos('~',S) = 0) or
     (Pos('=',S) = 0) or
     (Pos('(',S) = 0) or
     (Pos(')',S) = 0) or
     (Pos(',',S) = 0) then Exit;

  P := Pos('~',S)+1;
  L := Pos('=',S)-P;
  ElName := SpaceCut(Copy(S,P,L));

  P := Pos('=',S)+1;
  L := Pos('(',S)-P;
  WS     := SpaceCut(Copy(S,P,L));
  ElType := WS[1];

  P := Pos('(',S)+1;
  L := Pos(',',S)-P;
  WS     := SpaceCut(Copy(S,P,L));
  Val(WS,ElLen,I);
  if I > 0 then Exit;

  P := Pos(',',S)+1;
  L := Pos(')',S)-P;
  WS     := SpaceCut(Copy(S,P,L));
  Val(WS,ElDec,I);
  if I > 0 then Exit;
end;

{.........................................................................}
destructor  TBaseElem.Done;
begin
  ElName := '';
  ElType := #0;
  ElLen  := 0;
  ElDec  := 0;
  inherited Done;
end;

{.........................................................................}
constructor TBaseList.Init;
var
  RS : String;
begin
  inherited Init;
  InitF := False;
  List := New(PCollection,Init(10,10));

  TxtName := '';
  if TxtFName <> '' then
  begin
    if not FileExists(TxtFName) then
    begin
      cbResult := crEFileNotFound;
      Exit;
    end;

    Assign(TxtF,TxtFName);
    Reset(TxtF);
    TxtName := TxtFName;

    repeat
     ReadLn(TxtF,RS);
     Add(RS);
    until EoF(TxtF);
  end;

  InitF := True;
  cbResult := 0;
end;

{.........................................................................}
destructor  TBaseList.Done;
begin
  if InitF then
   begin
     if List <> nil then
     begin
       Dispose(List,Done);
       List := nil;
     end;
     if TxtName <> '' then System.Close(TxtF);
     cbResult := 0;
     inherited Done;
   end;
end;

{.........................................................................}
procedure TBaseList.Add(RS: String);
var
  PBEl :PBaseElem;
begin
  if List <> nil then
  begin
    RS := AnsiUpperCase(SpaceCut(RS));
    if (RS <> '') and
       (RS[1] = '~') then
    begin
      PBEl := New(PBaseElem,Init(RS));
      if PBEl <> nil then List^.Insert(PBEl);
    end;
  end;
end;


{.........................................................................}
function   TBaseList.GetElem;
begin
  if InitF then
   begin
    if ItemNum < List^.Count then GetElem := List^.At(ItemNum)
   end
     else GetElem := nil;
end;

{.........................................................................}
function   TBaseList.GetCount : Integer;
begin
  if InitF then cbResult := List^.Count
           else cbResult := 0;
  GetCount := cbResult;
end;

{---------------------------------------------------------------------------}
constructor TDBF.Init;
var
  I,I1 : Integer;
  DispField : Word;
  S : String[80];
  B : Byte;
  PD : PDescriptor;
  D,N,E: String;

  begin
    inherited Init;
    DList := nil;
  {........................................................}
  {      (ᮧ) 䠩            }
  {........................................................}
    D := ExtractFilePath(DBName);
    N := ExtractFileName(DBName);
    E := ExtractFileExt(DBName);

    if SpaceCut(N) = '' then { ᫨   ... }
     begin
      FlagInit := 0;
      Res := dbfENoFileName;
      ErrorHandle(Res);       { ... ࠡ 訡 ... }
      Exit               { ...  訬 ࠡ . }
     end;

    if E = '' then DBFName := D +N +'.DBF'
              else if E <> '.DBF' then DbfName := D + ChangeFileExt(N,'.DBF')
                                  else DBFName := D +N;

  {........................................................}
   if not FileExists(DBFName) then
     BEGIN             {***    ***}
       try
        DBFHandle := FileCreate(DBFName);  { ... c 䠩... }
        try
         DBFHandle := FileOpen(DBFName,fmOpenReadWrite);
        except
         FlagInit := 0;
         Res := dbfEOpen;
         ErrorHandle(Res);       { ... ࠡ 訡 ... }
         Exit
        end;
        Res := dbfFileEmpty; { ⠭ ਧ ⮣ 䠩 }
        FlagInit := 123;
       except
        FlagInit := 0;
        Res := dbfECreate;
        ErrorHandle(Res);       { ... ࠡ 訡 ... }
        Exit
       end;
     END
       ELSE       { ...  - ᫨ 䠩  ... }
     BEGIN      {***    ***}
       try
        DBFHandle := FileOpen(DBFName,fmOpenReadWrite);
       except
        FlagInit := 0;
        Res := dbfEOpen;
        ErrorHandle(Res);       { ... ࠡ 訡 ... }
        Exit
       end;

       {........................................................}
       {     ⥭   ࠡ⪨ ࠬ஢        }
       {........................................................}

       Res := FileRead(DBFHandle,DBFHeader,32); { ⥬    }
       if Res = 0 then
        begin
          FlagInit := 0;
          Res := dbfFileEmpty; { ⠭ ਧ ⮣ 䠩 }
          Exit;
        end
         else
        if Res = -1 then
         begin
           FlagInit := 0;
           FileClose(DBFHandle); { ஥ 䠩  }
           Res := dbfERead;
           ErrorHandle(Res);       { ... ࠡ 訡 ... }
           Exit
         end
          else
         if Res <> SizeOf(DBFHeader) then  { ᫨ ⠭  祬  }
          begin
            FlagInit := 0;
            FileClose(DBFHandle); { ஥ 䠩  }
            Res := dbfEDestruct; { ⠭ ਧ ࠧ襭  }
            ErrorHandle(Res);       { ... ࠡ 訡 ... }
            Exit;
          end;

       DispField := 1;  { 砫쭮 祭 ᬥ饭 = 1 }

       DList := New(PCollection,Init(20,10)); {   }

       for I := 1 to Pred(DBFHeader.HeaderSize div 32) do
        begin                   { ⥬    ᯨ᮪ }
          Res := FileRead(DBFHandle,Descriptor,32);
          if Res = -1 then  { ᫨ 訡 ⥭ pp }
           begin
             FlagInit := 0;
             if DList <> nil then
              begin
                Dispose(DList,Done);
                DList := nil;
              end;
             FileClose(DBFHandle); { ஥ 䠩  }
             Res := dbfERead;
             ErrorHandle(Res);       { ... ࠡ 訡 ... }
             Exit
           end;

          if MaxAvail < 32 then { ᫨   }
           begin
             FlagInit := 0;
             if DList <> nil then
              begin
                Dispose(DList,Done);
                DList := nil;
              end;
             FileClose(DBFHandle); { ஥ 䠩  }
             Res := dbfEOutOfMemory;
             ErrorHandle(Res);       { ... ࠡ 訡 ... }
             Exit
           end;

          with Descriptor do
           begin
           {----------- ࠭ 祭 ᬥ饭  --------}
             FieldDisp := DispField;
             Inc(DispField,FieldLen);
           end;
          PD := New(PDescriptor,Init(Descriptor));
          DList^.Insert(PD);
        end;
     END;
   FlagInit := 123;
 end;

{............................................................................}
destructor TDBF.Done;
var
  I1 : Integer;
begin
  if DBFHeader.RecCount = 0 then WriteHeader;
  if DList <> nil then
   begin
     Dispose(DList,Done);
     DList := nil;
   end;
  FileClose(DBFHandle); { ஥ 䠩  }
  FlagInit := 0;
  inherited Done;
end;

procedure TDBF.InitStructFile(SName : String);
begin
  if SName = '' then STRName := ChangeFileExt(DBFName,'.STR')
                else STRName := SName;


end;

{............................................................................}
{   楤 㭨⮦ 䠩                                    }
{............................................................................}
procedure TDBF.EraseDB;
var
  I1 : Integer;
begin
  if DList <> nil then
   begin
     Dispose(DList,Done);
     DList := nil;
   end;
  FileClose(DBFHandle);
  if DeleteFile(DBFName) then Res := 0
                         else
                          begin
                            Res := 1;
                            Exit;
                          end;

  FlagInit := 0;

  try
   DBFHandle := FileCreate(DBFName);  { ... c 䠩... }
   FileClose(DBFHandle);
   try
    DBFHandle := FileOpen(DBFName,fmOpenReadWrite);
   except
    FlagInit := 0;
    Res := dbfEOpen;
    ErrorHandle(Res);       { ... ࠡ 訡 ... }
    Exit
   end;
   Res := dbfFileEmpty; { ⠭ ਧ ⮣ 䠩 }
   DBFHeader.RecCount := 0;
  except
   FlagInit := 0;
   Res := dbfECreate;
   ErrorHandle(Res);       { ... ࠡ 訡 ... }
   Exit
  end;
end;

{............................................................................}
{   楤 ࠡ⪨ 訡 ()    ⮬            }
{............................................................................}
procedure TDBF.ErrorHandle;
var
  S : String;
begin
  case Error of
   dbfFileEmpty    : S := ' ';
   dbfENoFileName  : S := ' 㪠  䠩';
   dbfEFileNotFound: S := '  ';
   dbfECreate      : S := '訡 ᮧ 䠩';
   dbfEOpen        : S := '訡  䠩';
   dbfESeek        : S := '訡 樮஢ 䠩';
   dbfERead        : S := '訡 ⥭ 䠩';
   dbfEWrite       : S := '訡   䠩';
   dbfEOutOfMemory : S := '筮 ';
   dbfEDestruct    : S := '  ࠧ襭';
   dbfECreateList  : S := '訡 ᮧ ᯨ᪠ ਯ஢';
   dbfEOutOfNumber : S := '室  । ';
   else              S := '⭠ 訡';
  end;
  MessageDlg(S,mtWarning,[mbOK],0);
end;

{............................................................................}
{  ⮢ ⮩                                               }
{............................................................................}
procedure TDBF.CreateHeader(FType : Byte);
var
 Y,M,D,DW : Word;
begin
   if DBFHeader.RecCount > 0 then Exit;

   FillChar(DBFHeader,32,#0);

   with DBFHeader do
    begin
     DBType := FType;
     DecodeDate(Date,Y,M,D);
     Year  := Y - 1900;
     Month := M;
     Day   := D;
     HeaderSize  := 33;
     RecordSize := 1;
    end;
end;

{............................................................................}
{     䠩                                                 }
{............................................................................}
procedure TDBF.WriteHeader;
var
 I : Integer;
 B : Byte;
 PD : PDescriptor;
  begin
     if (FlagInit <> 123) or
        (DBFHeader.RecCount > 0) then Exit;

     Res := FileSeek(DBFHandle,0,0);  { ⠭  砫 䠩 }

     Res := FileWrite(DBFHandle,DBFHeader,32); { ࠭   }
     if Res = -1 then
      begin
       Res := dbfEWrite;
       ErrorHandle(Res);       { ... ࠡ 訡 ... }
       Exit;
      end;

     if DList <> nil then
      if DList^.Count > 0 then  { ᫨ ।  ... }
       for I := 0 to DList^.Count -1 do  { ...  横 ... }
        begin
          PD := DList^.At(I); { ... ࠭  ᠭ  䠩 }
          PD^.GetData(Descriptor);

          Res := FileWrite(DBFHandle,Descriptor,32);
          if Res = -1 then { ᫨ ⪠  㤠筠 ... }
           begin
             Res := dbfEWrite;
             ErrorHandle(Res);       { ... ࠡ 訡 ... }
             Exit;
           end;
        end;

     B := $0D;
     Res := FileWrite(DBFHandle,B,1);
  end;

{............................................................................}
function TDBF.DeleteMDX :Byte;
var
 MDXPath : String;
 I : Integer;
 B : Byte;
 PD : PDescriptor;

begin
  if (FlagInit <> 123) then Exit; { ᫨    ࠢ 䠩 }

  Res := 0;

  MDXPath := ChangeFileExt(DBFName,'.MDX');

  if FileExists(MDXPath) then
   if not DeleteFile(MDXPath) then Res := Res or $00000008;

  DBFHeader.FlagMDX := 0;

  Res := FileSeek(DBFHandle,0,0);  { ⠭  砫 䠩 }

  Res := FileWrite(DBFHandle,DBFHeader,32); { ࠭   }
  if Res = -1 then
   begin
     Res := dbfEWrite;
     ErrorHandle(Res);       { ... ࠡ 訡 ... }
     Exit;
   end;

end;

{............................................................................}
function TDBF.CreateBaseStructOnFile : Boolean;
var
  PBI      : PBaseElem;
  BaseList : PBaseList; { ᠭ   }
  I        : Integer;

begin
  if not FileExists(STRName) then
   begin
     Res := dbfEFileNotFound;
     ErrorHandle(Res);
     Exit;
   end;

  BaseList := nil; 
 {  -⥫    }
  BaseList := New(PBaseList,Init(STRName));
  if BaseList = nil then  { ᫨ 訡 樠樨 }
   begin
     CreateBaseStructOnFile := False;
     Exit;
   end;

  FlagInit := 123;
  CreateHeader(dBaseIII);

  for I := 0 to BaseList^.List^.Count -1 do
   begin
     PBI := BaseList^.List^.At(I);
     with PBI^ do AppendField(ElName,ElType,ElLen,ElDec);
   end;
  WriteHeader;

  FileClose(DBFHandle);

  try
   DBFHandle := FileOpen(DBFName,fmOpenReadWrite);
  except
   FlagInit := 0;
   Res := dbfEOpen;
   ErrorHandle(Res);       { ... ࠡ 訡 ... }
   Exit
  end;
  if BaseList <> nil then
  begin
    Dispose(BaseList,Done);
    BaseList := nil;
  end;
  CreateBaseStructOnFile := True;
end;

{............................................................................}
function TDBF.CreateBaseStructOnList(BaseList: PBaseList) : Boolean;
var
  PBI      : PBaseElem;
  I        : Integer;

begin
  if BaseList = nil then
   begin
     CreateBaseStructOnList := False;
     Exit;
   end;

  FlagInit := 123;
  CreateHeader(dBaseIII);

  for I := 0 to BaseList^.List^.Count -1 do
   begin
     PBI := BaseList^.List^.At(I);
     with PBI^ do AppendField(ElName,ElType,ElLen,ElDec);
   end;
  WriteHeader;

  FileClose(DBFHandle);

  try
   DBFHandle := FileOpen(DBFName,fmOpenReadWrite);
  except
   FlagInit := 0;
   Res := dbfEOpen;
   ErrorHandle(Res);       { ... ࠡ 訡 ... }
   Exit
  end;

  CreateBaseStructOnList := True;
end;

{............................................................................}
{                                                }
{............................................................................}
procedure TDBF.AppendField(Name : String; FTp : Char; LenI,LenD : Byte);
var
  PD : PDescriptor;

 begin
    if (FlagInit <> 123) or { ᫨    ࠢ 䠩 }
       (DBFHeader.RecCount > 0) then Exit; { ᫨ 㦥   - ⮨ ᪮ !}

    if DList = nil then  { ᫨  ᯨ᪠ ਯ஢ }
     begin
       if MaxAvail < 32 * 20 then { ᫨   }
        begin
          Res := dbfEOutOfMemory;
          ErrorHandle(Res);       { ... ࠡ 訡 ... }
          Exit
        end;
        { १ࢨ஢   ᯨ᮪ ਯ஢ }
        DList := New(PCollection,Init(10,10));
     end;

    FillChar(Descriptor,SizeOf(Descriptor),#0); { ⨬ ਯ }

    with Descriptor do {  ਯ }
     begin
       Name := AnsiUpperCase(SpaceCut(Name)); { ਢ   孥 ॣ }
       if Length(Name) > 10 then Name := Copy(Name,1,10);
       Move(Name[1],FieldName[1],Length(Name)); { ࠭   }
       FieldType := UpCase(FTp);  {   }

       case FieldType of
       'C': begin
              FieldLen := LenI;  {  ப }
              FieldDec := 0;
            end;
       'D': begin
              FieldLen := 8;     {   }
              FieldDec := 0;
            end;
       'L': begin
              FieldLen := 1;     {    㫥᪮ ६ }
              FieldDec := 0;
            end;
       'M': begin
              FieldLen := 10;    {  MEMO }
              FieldDec := 0;
            end;
       'N': begin
              if LenI > 15 then FieldLen := 15
                           else FieldLen := LenI;  {   }
              if LenD > Pred(LenI) then FieldDec := Pred(LenI)
                                   else FieldDec := LenD;
            end;
       end;

       Inc(DBFHeader.HeaderSize,32);
       Inc(DBFHeader.RecordSize,FieldLen);
     end;

    if MaxAvail < 32 then { ᫨   }
     begin
       Res := dbfEOutOfMemory;
       ErrorHandle(Res);       { ... ࠡ 訡 ... }
       Exit
     end;

    if DList^.Count = 0 then Descriptor.FieldDisp := 1
      else
       begin { ᫨ ᬥ饭   ⭮⥫쭮 ।饣 }
         with DList^ do PD := At(Count-1);
         Descriptor.FieldDisp := PD^.FieldDisp+PD^.FieldLen;
       end;

    PD := New(PDescriptor,Init(Descriptor));
    if PD <> nil then DList^.Insert(PD);
 end;

{............................................................................}
function  TDBF.GetNumField(Name : String) :Integer;
var
  S0 : String;
  I : Integer;

begin
  if (FlagInit = 123) then
   begin
     S0 := AnsiUpperCase(SpaceCut(Name));
     if S0 <> '' then
      for I := 0 to DList^.Count -1 do
       with DList^ do
        begin
          if S0 = PDescriptor(At(I))^.GetName then
           begin
             GetNumField := I;
             Exit;
           end;
        end;
   end;
   GetNumField := -1;
end;

{............................................................................}
function  TDBF.GetFieldName;
begin
  if (Num > -1) and
     (Num <= DList^.Count -1) then
    GetFieldName := PDescriptor(DList^.At(Num))^.GetName
   else GetFieldname := '';
end;

{............................................................................}
function  TDBF.GetTypeNum(Num : Integer) :Char;
  begin
   if (FlagInit <> 123) then Exit;

   if Num > DList^.Count -1 then
               begin
                 GetTypeNum := #0;
                 Exit;
               end;

     GetTypeNum := PDescriptor(DList^.At(Num))^.GetType;
  end;

{............................................................................}
function  TDBF.GetType(Name : String) :Char;
var
 NF : Integer;
  begin
   if (FlagInit <> 123) then Exit;

   NF := GetNumField(Name);

   if NF = -1 then {   }
               begin
                 GetType := #0;
                 Exit;
               end;

   GetType := PDescriptor(DList^.At(NF))^.GetType;
  end;

{............................................................................}
function TDBF.GetLengthNum(Num : Integer): Integer;
  begin
   if (FlagInit <> 123) then Exit;

   if Num > DList^.Count -1 then
               begin
                 GetLengthNum := 0;
                 Exit;
               end;

     GetLengthNum := PDescriptor(DList^.At(Num))^.FieldLen;
  end;

{............................................................................}
function TDBF.GetLength(Name : String): Integer;
var
 NF : Integer;

 begin
   if (FlagInit <> 123) then Exit;

   NF := GetNumField(Name);

   if NF = -1 then {   }
               begin
                 GetLength := 0;
                 Exit;
               end;

   GetLength := PDescriptor(DList^.At(NF))^.FieldLen;
 end;

{............................................................................}
function TDBF.GetDispNum(Num : Integer): Integer;
  begin
   if (FlagInit <> 123) then Exit;

   if Num > DList^.Count -1 then
               begin
                 GetDispNum := 0;
                 Exit;
               end;

     GetDispNum := PDescriptor(DList^.At(Num))^.FieldDisp;
  end;

{............................................................................}
function TDBF.GetDisp(Name : String): Integer;
var
 NF : Integer;

 begin
   if (FlagInit <> 123) then Exit;

   NF := GetNumField(Name);

   if NF = -1 then {   }
               begin
                 GetDisp := 0;
                 Exit;
               end;

   GetDisp := PDescriptor(DList^.At(NF))^.FieldDisp;
 end;

{----------------------------------------------------------------------------}
function GetAliasPath(Alias : String) : String;
var
  AlList  : TStringList;
begin
  GetAliasPath := '';
  if Alias = '' then Exit;
  AlList := TStringList.Create; {  ꥪ TStringList }
  Session.GetAliasParams(Alias,AlList); { ⥬ ࠬ ᥢ }
  GetAliasPath := AlList.Values['PATH'];  { 祬   ⠫  }
  AlList.Destroy; {  ⠢訩 㦭 ꥪ }
end;

{----------------------------------------------------------------------------}
function  RealToString;
var
  S : String;
  L : Integer;
begin
  L := Ln;
  if L > 15 then L := 15;
  Str(D:L:Dc,S);
  RealToString := SpaceCut(S);
end;

{............................................................................}
function  StringToReal;
var
  I  : Integer;
  D  : Double;

begin
  Val(S,D,I);
  if I = 0 then StringToReal := D
           else StringToReal := 0;
end;

{............................................................................}
function  StringToInteger(S: String) : LongInt;
var
  I  : Integer;
  LI : Longint;

begin
  I := Pos('.',S);
  if I > 0 then S[0] := Chr(Pred(Lo(I)));

  Val(S,LI,I);
  if I = 0 then StringToInteger := LI
           else StringToInteger := 0;
end;

{=======================================================================}
end. { End library ... }
